import { StrictEffect, Effect, spawn, delay, put } from "redux-saga/effects";
declare type SagaGeneratorWithReturn<RT> = Generator<Effect, RT, any>;
declare type UnwrapReturnType<R> = R extends SagaGeneratorWithReturn<infer RT> ? RT : R extends Promise<infer PromiseValue> ? PromiseValue : R;
export declare type SagaGenerator = Generator<StrictEffect>;
export declare function call<Args extends any[], R>(fn: (...args: Args) => R, ...args: Args): SagaGeneratorWithReturn<UnwrapReturnType<R>>;
export declare function race<T extends Record<string, unknown>>(effects: T): SagaGeneratorWithReturn<{
    [P in keyof T]?: UnwrapReturnType<T[P]>;
}>;
export declare function all<T extends Record<string, unknown>>(effects: T): SagaGeneratorWithReturn<{
    [P in keyof T]: UnwrapReturnType<T[P]>;
}>;
export { spawn, delay, put };
